#include<iostream>//including all necessary header files
#include <CImg.h>
#include<graphics.h>
#include<cmath>
#include<cstring>
#include<sstream>

using namespace std;//using necessary namespaces
using namespace cimg_library;

class Index//each block of grid that makes up the map
{
    public:
    int route;
    string place;
    Index()//default constructor
    {
        route=-9;
    }
};

void dispLogo();//defining all necessary functions
void open();
int load_image();
void menu();

int directions();
void initialize(Index A[10][10],int I1[29],int I2[6]);
int directions_from(int c);
int directions_to(int c);
bool isPossible(Index maze[10][10],int x,int y,int visit[10][10],int c);
bool solveMaze(Index maze[10][10],int x,int y,int sol[10][10],int visit[10][10],int x2,int y2,int c);
int printSolution(int sol[10][10],int x1,int y1,int x2,int y2,Index A[10][10]);
void nearestLandmark(int x, int y,int k,Index biitmap[10][10]);

int nearest();
int nearestLandmarks(int x, int y,Index biitmap[10][10]);

int rel();
int relative(int x1,int y1,int x2,int y2,Index A[10][10]);

int tumtum_from();
int tumtum_to();
int tumtum();
int tumtum_time();

int help();

int hangout();

void thanks();

int main()//program execution begins here
{
    dispLogo();//startup screen
    open();//startup message
    menu();//menu display
    return 0;
}

void dispLogo()//startup screen
{
    CImg<unsigned char> image("Logo.bmp");
    CImgDisplay main_disp(image,"MAP");
    main_disp.move(0,10);
    delay(1500);
    main_disp.close();
    return;
}

void open()//startup message
{
    initwindow(1368,750,"Windows BGI",0,-20,FALSE,TRUE);

    for(int  i=0;i<2;i++)
    {
        setcolor(CYAN);
        settextstyle(2,HORIZ_DIR,50);
        outtextxy(500,300,"BIITMaps v1.0");
        settextstyle(10,HORIZ_DIR,2);
        outtextxy(600,400,"Loading");
        delay(500);
        cleardevice();
        settextstyle(2,HORIZ_DIR,50);
        outtextxy(500,300,"BIITMaps v1.0");
        settextstyle(10,HORIZ_DIR,2);
        outtextxy(600,400,"Loading .");
        delay(500);
        cleardevice();
        settextstyle(2,HORIZ_DIR,50);
        outtextxy(500,300,"BIITMaps v1.0");
        settextstyle(10,HORIZ_DIR,2);
        outtextxy(600,400,"Loading . .");
        delay(500);
        cleardevice();
        settextstyle(2,HORIZ_DIR,50);
        outtextxy(500,300,"BIITMaps v1.0");
        settextstyle(10,HORIZ_DIR,2);
        outtextxy(600,400,"Loading . . .");
        delay(500);
        cleardevice();
    }
    return;
}

void menu()//displays menu
{
    T :
    setcolor(2);

    rectangle(100,120,500,220);//display background
    rectangle(100,270,500,370);
    rectangle(100,420,500,520);
    rectangle(100,570,500,670);

    rectangle(99,119,501,221);
    rectangle(99,269,501,371);
    rectangle(99,419,501,521);
    rectangle(99,569,501,671);

    setcolor(3);
    settextstyle(10,HORIZ_DIR,4);
    outtextxy(130,155,"Get Directions");//text of options
    outtextxy(130,305,"Nearest Landmarks");
    outtextxy(130,455,"Relative Locations");
    outtextxy(130,605,"Hangouts");

    setcolor(2);
    rectangle(850,120,1250,220);
    rectangle(850,270,1250,370);
    rectangle(850,570,1250,670);

    rectangle(849,119,1251,221);
    rectangle(849,269,1251,371);
    rectangle(849,569,1251,671);

    setcolor(3);
    settextstyle(10,HORIZ_DIR,4);
    outtextxy(880,155,"Tum Tum");
    outtextxy(880,305,"Help");
    outtextxy(880,605,"Exit");

    setcolor(3);

    settextstyle(8,HORIZ_DIR,3);
    outtextxy(620,30,"Welcome to");

    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");

    int x, y;        // Coordinates of the mouse click
    int divisor;     // Divisor for the length of a triangle side

    S : //Label to initiate mouse click again

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y

    if(((x>=100)&&(x<=500))&&((y>=120)&&(y<=220)))    //Get Directions
    {
        int z=directions();
        initwindow(1368,750,"Windows BGI",0,-20,FALSE,TRUE);
        if(z==0)
        {
            thanks();
        }
    }
    else
    if(((x>=100)&&(x<=500))&&((y>=270)&&(y<=370)))   //Nearest Landmarks
    {
        int z=nearest();
        initwindow(1368,750,"Windows BGI",0,-20,FALSE,TRUE);
        if(z==0)
        {
            thanks();
        }
    }
    else
    if(((x>=100)&&(x<=500))&&((y>=420)&&(y<=520)))  //Relative Locations
    {
        int z=rel();
        initwindow(1368,750,"Windows BGI",0,-20,FALSE,TRUE);
        if(z==0)
        {
            thanks();
        }
    }
    else
    if(((x>=100)&&(x<=500))&&((y>=570)&&(y<=670)))  //Hangouts
    {
        int z=hangout();
        initwindow(1368,750,"Windows BGI",0,-20,FALSE,TRUE);
        if(z==0)
        {
            thanks();
        }
    }
    else
    if(((x>=850)&&(x<=1250))&&((y>=120)&&(y<=220)))  //Tum Tum : User
    {
        int z=tumtum();
        initwindow(1368,750,"Windows BGI",0,-20,FALSE,TRUE);
        if(z==0)
        {
            thanks();
        }
    }
    else
    if(((x>=850)&&(x<=1250))&&((y>=270)&&(y<=370)))  //Help
    {
        int z=help();
        if(z==0)
        {
            thanks();
        }
    }
    else
    if(((x>=850)&&(x<=1250))&&((y>=570)&&(y<=670)))  //Exit
    {
        thanks();
    }
    else
    {
    goto S;
    }
    goto T;
}

int directions_from(int c)//starting point input
{

    setcolor(2);
    rectangle(75,200,265,240);
    rectangle(75,240,265,280);
    rectangle(75,280,265,320);
    rectangle(75,320,265,360);
    rectangle(75,360,265,400);
    rectangle(75,400,265,440);
    rectangle(75,440,265,480);
    rectangle(75,480,265,520);
    rectangle(75,520,265,560);
    rectangle(75,560,265,600);

    rectangle(275,200,465,240);
    rectangle(275,240,465,280);
    rectangle(275,280,465,320);
    rectangle(275,320,465,360);
    rectangle(275,360,465,400);
    rectangle(275,400,465,440);
    rectangle(275,440,465,480);
    rectangle(275,480,465,520);
    rectangle(275,520,465,560);

    rectangle(475,200,665,240);
    rectangle(475,240,665,280);
    rectangle(475,280,665,320);
    rectangle(475,320,665,360);
    rectangle(475,360,665,400);
    rectangle(475,400,665,440);
    rectangle(475,440,665,480);
    rectangle(475,480,665,520);
    rectangle(475,520,665,560);
    rectangle(475,560,665,600);

    if(c==1)
    {
        rectangle(75,600,265,640);
        rectangle(75,640,265,680);

        rectangle(275,560,465,600);
        rectangle(275,600,465,640);

        rectangle(475,600,665,640);
        rectangle(75,680,265,720);
    }

    setcolor(3);
    settextstyle(10,HORIZ_DIR,2);
    outtextxy(115,210,"Hostel 1");
    outtextxy(115,250,"Hostel 2");
    outtextxy(115,290,"Hostel 3");
    outtextxy(115,330,"Hostel 4");
    outtextxy(115,370,"Hostel 5");
    outtextxy(115,410,"Hostel 7");
    outtextxy(115,450,"Hostel 8");
    outtextxy(115,490,"Hostel 9");
    outtextxy(115,530,"Hostel 10");
    outtextxy(115,570,"Hostel 11");

    outtextxy(280,210,"Hostel 12,13,14");
    outtextxy(295,250,"Hostel 15");
    outtextxy(295,290,"Ananta");
    outtextxy(295,330,"Vihar House");
    outtextxy(295,370,"SysCon");
    outtextxy(295,410,"UG Labs");
    outtextxy(295,450,"PHO");
    outtextxy(295,490,"CDEEP");
    outtextxy(295,530,"Mech Workshop");

    outtextxy(495,210,"Main Building");
    outtextxy(495,250,"VMCC");
    outtextxy(495,290,"IIT hospital");
    outtextxy(495,330,"Gulmohar");
    outtextxy(495,370,"3 Pole Road");
    outtextxy(495,410,"KV, IIT Powai");
    outtextxy(495,450,"YP Gate");
    outtextxy(495,490,"Temple");
    outtextxy(495,530,"Main Gate");
    outtextxy(490,570,"Lake Side Gate");

    if(c==1)
    {
        outtextxy(115,610,"Hostel 16");
        outtextxy(115,650,"Hostel 6");

        outtextxy(295,570,"Academic Area");
        outtextxy(295,610,"SJM SOM");

        outtextxy(495,610,"Infi Corridor");
        outtextxy(115,690,"SBI");
    }

    int x, y;        // Coordinates of the mouse click
    int divisor;
    P : //Label to initiate mouse click again

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y
    setcolor(RED);
    if(((x>=75)&&(x<=265))&&((y>=200)&&(y<=240)))
    {
        outtextxy(115,210,"Hostel 1");
        return 0;
    }else
    if(((x>=75)&&(x<=265))&&((y>=240)&&(y<=280)))
    {
        outtextxy(115,250,"Hostel 2");
        return 1;
    }else
    if(((x>=75)&&(x<=265))&&((y>=280)&&(y<=320)))
    {
        outtextxy(115,290,"Hostel 3");
        return 2;
    }else
    if(((x>=75)&&(x<=265))&&((y>=320)&&(y<=360)))
    {
        outtextxy(115,330,"Hostel 4");
        return 3;
    }else
    if(((x>=75)&&(x<=265))&&((y>=360)&&(y<=400)))
    {
        outtextxy(115,370,"Hostel 5");
        return 4;
    }else
    if(((x>=75)&&(x<=265))&&((y>=400)&&(y<=440)))
    {
        outtextxy(115,410,"Hostel 7");
        return 5;
    }else
    if(((x>=75)&&(x<=265))&&((y>=440)&&(y<=480)))
    {
        outtextxy(115,450,"Hostel 8");
        return 6;
    }else
    if(((x>=75)&&(x<=265))&&((y>=480)&&(y<=520)))
    {
        outtextxy(115,490,"Hostel 9");
        return 7;
    }else
    if(((x>=75)&&(x<=265))&&((y>=520)&&(y<=560)))
    {
        outtextxy(115,530,"Hostel 10");
        return 8;
    }else
    if(((x>=75)&&(x<=265))&&((y>=560)&&(y<=600)))
    {
        outtextxy(115,570,"Hostel 11");
        return 9;
    }else

    if(((x>=275)&&(x<=465))&&((y>=200)&&(y<=240)))
    {
        outtextxy(280,210,"Hostel 12,13,14");
        return 10;
    }else
    if(((x>=275)&&(x<=465))&&((y>=240)&&(y<=280)))
    {
        outtextxy(295,250,"Hostel 15");
        return 11;
    }else
    if(((x>=275)&&(x<=465))&&((y>=280)&&(y<=320)))
    {
        outtextxy(295,290,"Ananta");
        return 12;
    }else
    if(((x>=275)&&(x<=465))&&((y>=320)&&(y<=360)))
    {
        outtextxy(295,330,"Vihar House");
        return 13;
    }else
    if(((x>=275)&&(x<=465))&&((y>=360)&&(y<=400)))
    {
        outtextxy(295,370,"SysCon");
        return 14;
    }else
    if(((x>=275)&&(x<=465))&&((y>=400)&&(y<=440)))
    {
        outtextxy(295,410,"UG Labs");
        return 15;
    }else
    if(((x>=275)&&(x<=465))&&((y>=440)&&(y<=480)))
    {
        outtextxy(295,450,"PHO");
        return 16;
    }else
    if(((x>=275)&&(x<=465))&&((y>=480)&&(y<=520)))
    {
        outtextxy(295,490,"CDEEP");
        return 17;
    }else
    if(((x>=275)&&(x<=465))&&((y>=520)&&(y<=560)))
    {
        outtextxy(295,530,"Mech Workshop");
        return 18;
    }else


    if(((x>=475)&&(x<=665))&&((y>=200)&&(y<=240)))
    {
        outtextxy(495,210,"Main Building");
        return 19;
    }else
    if(((x>=475)&&(x<=665))&&((y>=240)&&(y<=280)))
    {
        outtextxy(495,250,"VMCC");
        return 20;
    }else
    if(((x>=475)&&(x<=665))&&((y>=280)&&(y<=320)))
    {
        outtextxy(495,290,"IIT hospital");
        return 21;
    }else
    if(((x>=475)&&(x<=665))&&((y>=320)&&(y<=360)))
    {
        outtextxy(495,330,"Gulmohar");
        return 22;
    }else
    if(((x>=475)&&(x<=665))&&((y>=360)&&(y<=400)))
    {
        outtextxy(495,370,"3 Pole Road");
        return 23;
    }else
    if(((x>=475)&&(x<=665))&&((y>=400)&&(y<=440)))
    {
        outtextxy(495,410,"KV, IIT Powai");
        return 24;
    }else
    if(((x>=475)&&(x<=665))&&((y>=440)&&(y<=480)))
    {
        outtextxy(495,450,"YP Gate");
        return 25;
    }else
    if(((x>=475)&&(x<=665))&&((y>=480)&&(y<=520)))
    {
        outtextxy(495,490,"Temple");
        return 26;
    }else
    if(((x>=475)&&(x<=665))&&((y>=520)&&(y<=560)))
    {
        outtextxy(495,530,"Main Gate");
        return 27;
    }else
    if(((x>=475)&&(x<=665))&&((y>=560)&&(y<=600)))
    {
        outtextxy(490,570,"Lake Side Gate");
        return 28;
    }else

    {
    if(c==1)
    {
        if(((x>=75)&&(x<=265))&&((y>=600)&&(y<=640)))
        {
            outtextxy(115,610,"Hostel 16");
            return 29;
        }
        else if(((x>=75)&&(x<=265))&&((y>=640)&&(y<=680)))
        {
            outtextxy(115,650,"Hostel 6");
            return 30;
        }
        else if(((x>=275)&&(x<=465))&&((y>=560)&&(y<=600)))
        {
            outtextxy(295,570,"Academic Area");
            return 31;
        }
        else if(((x>=275)&&(x<=465))&&((y>=600)&&(y<=640)))
        {
            outtextxy(295,610,"SJM SOM");
            return 32;
        }
        else if(((x>=475)&&(x<=665))&&((y>=600)&&(y<=640)))
        {
            outtextxy(495,610,"Infi Corridor");
            return 33;
        }
        else if(((x>=75)&&(x<=265))&&((y>=680)&&(y<=720)))
        {
            outtextxy(115,690,"SBI");
            return 34;
        }
        else
        {
            goto P;
        }
    }
    else
    {
        goto P;
    }
    }
}

int directions_to(int c)//ending point input
{

    setcolor(2);
    rectangle(705,200,895,240);
    rectangle(705,240,895,280);
    rectangle(705,280,895,320);
    rectangle(705,320,895,360);
    rectangle(705,360,895,400);
    rectangle(705,400,895,440);
    rectangle(705,440,895,480);
    rectangle(705,480,895,520);
    rectangle(705,520,895,560);
    rectangle(705,560,895,600);

    rectangle(905,200,1095,240);
    rectangle(905,240,1095,280);
    rectangle(905,280,1095,320);
    rectangle(905,320,1095,360);
    rectangle(905,360,1095,400);
    rectangle(905,400,1095,440);
    rectangle(905,440,1095,480);
    rectangle(905,480,1095,520);
    rectangle(905,520,1095,560);

    rectangle(1105,200,1295,240);
    rectangle(1105,240,1295,280);
    rectangle(1105,280,1295,320);
    rectangle(1105,320,1295,360);
    rectangle(1105,360,1295,400);
    rectangle(1105,400,1295,440);
    rectangle(1105,440,1295,480);
    rectangle(1105,480,1295,520);
    rectangle(1105,520,1295,560);
    rectangle(1105,560,1295,600);

    if(c==1)
    {
        rectangle(705,600,895,640);
        rectangle(705,640,895,680);

        rectangle(905,560,1095,600);
        rectangle(905,600,1095,640);

        rectangle(1105,600,1295,640);
        rectangle(705,680,895,720);
    }

    setcolor(3);
    settextstyle(10,HORIZ_DIR,2);
    outtextxy(745,210,"Hostel 1");
    outtextxy(745,250,"Hostel 2");
    outtextxy(745,290,"Hostel 3");
    outtextxy(745,330,"Hostel 4");
    outtextxy(745,370,"Hostel 5");
    outtextxy(745,410,"Hostel 7");
    outtextxy(745,450,"Hostel 8");
    outtextxy(745,490,"Hostel 9");
    outtextxy(745,530,"Hostel 10");
    outtextxy(745,570,"Hostel 11");

    outtextxy(910,210,"Hostel 12,13,14");
    outtextxy(925,250,"Hostel 15");
    outtextxy(925,290,"Ananta");
    outtextxy(925,330,"Vihar House");
    outtextxy(925,370,"SysCon");
    outtextxy(925,410,"UG Labs");
    outtextxy(925,450,"PHO");
    outtextxy(925,490,"CDEEP");
    outtextxy(925,530,"Mech Workshop");

    outtextxy(1125,210,"Main Building");
    outtextxy(1125,250,"VMCC");
    outtextxy(1125,290,"IIT hospital");
    outtextxy(1125,330,"Gulmohar");
    outtextxy(1125,370,"3 Pole Road");
    outtextxy(1125,410,"KV, IIT Powai");
    outtextxy(1125,450,"YP Gate");
    outtextxy(1125,490,"Temple");
    outtextxy(1125,530,"Main Gate");
    outtextxy(1120,570,"Lake Side Gate");

    if(c==1)
    {
        outtextxy(745,610,"Hostel 16");
        outtextxy(745,650,"Hostel 6");

        outtextxy(925,570,"Academic Area");
        outtextxy(925,610,"SJM SOM");

        outtextxy(1125,610,"Infi Corridor");
        outtextxy(745,690,"SBI");
    }


    int x, y;        // Coordinates of the mouse click
    int divisor;

    L : //Label to initiate mouse click again

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y
    setcolor(RED);
    if(((x>=705)&&(x<=895))&&((y>=200)&&(y<=240)))
    {
        outtextxy(745,210,"Hostel 1");
        return 0;
    }else
    if(((x>=705)&&(x<=895))&&((y>=240)&&(y<=280)))
    {
        outtextxy(745,250,"Hostel 2");
        return 1;
    }else
    if(((x>=705)&&(x<=895))&&((y>=280)&&(y<=320)))
    {
        outtextxy(745,290,"Hostel 3");
        return 2;
    }else
    if(((x>=705)&&(x<=895))&&((y>=320)&&(y<=360)))
    {
        outtextxy(745,330,"Hostel 4");
        return 3;
    }else
    if(((x>=705)&&(x<=895))&&((y>=360)&&(y<=400)))
    {
        outtextxy(745,370,"Hostel 5");
        return 4;
    }else
    if(((x>=705)&&(x<=895))&&((y>=400)&&(y<=440)))
    {
        outtextxy(745,410,"Hostel 7");
        return 5;
    }else
    if(((x>=705)&&(x<=895))&&((y>=440)&&(y<=480)))
    {
        outtextxy(745,450,"Hostel 8");
        return 6;
    }else
    if(((x>=705)&&(x<=895))&&((y>=480)&&(y<=520)))
    {
        outtextxy(745,490,"Hostel 9");
        return 7;
    }else
    if(((x>=705)&&(x<=895))&&((y>=520)&&(y<=560)))
    {
        outtextxy(745,530,"Hostel 10");
        return 8;
    }else
    if(((x>=705)&&(x<=895))&&((y>=560)&&(y<=600)))
    {
        outtextxy(745,570,"Hostel 11");
        return 9;
    }else

    if(((x>=905)&&(x<=1095))&&((y>=200)&&(y<=240)))
    {
        outtextxy(910,210,"Hostel 12,13,14");
        return 10;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=240)&&(y<=280)))
    {
        outtextxy(925,250,"Hostel 15");
        return 11;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=280)&&(y<=320)))
    {
        outtextxy(925,290,"Ananta");
        return 12;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=320)&&(y<=360)))
    {
        outtextxy(925,330,"Vihar House");
        return 13;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=360)&&(y<=400)))
    {
        outtextxy(925,370,"SysCon");
        return 14;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=400)&&(y<=440)))
    {
        outtextxy(925,410,"UG Labs");
        return 15;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=440)&&(y<=480)))
    {
        outtextxy(925,450,"PHO");
        return 16;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=480)&&(y<=520)))
    {
        outtextxy(925,490,"CDEEP");
        return 17;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=520)&&(y<=560)))
    {
        outtextxy(925,530,"Mech Workshop");
        return 18;
    }else


    if(((x>=1105)&&(x<=1295))&&((y>=200)&&(y<=240)))
    {
        outtextxy(1125,210,"Main Building");
        return 19;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=240)&&(y<=280)))
    {
        outtextxy(1125,250,"VMCC");
        return 20;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=280)&&(y<=320)))
    {
        outtextxy(1125,290,"IIT hospital");
        return 21;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=320)&&(y<=360)))
    {
        outtextxy(1125,330,"Gulmohar");
        return 22;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=360)&&(y<=400)))
    {
        outtextxy(1125,370,"3 Pole Road");
        return 23;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=400)&&(y<=440)))
    {
        outtextxy(1125,410,"KV, IIT Powai");
        return 24;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=440)&&(y<=480)))
    {
        outtextxy(1125,450,"YP Gate");
        return 25;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=480)&&(y<=520)))
    {
        outtextxy(1125,490,"Temple");
        return 26;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=520)&&(y<=560)))
    {
        outtextxy(1125,530,"Main Gate");
        return 27;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=560)&&(y<=600)))
    {
        outtextxy(1120,570,"Lake Side Gate");
        return 28;
    }else
    {
    if(c==1)
    {
        if(((x>=705)&&(x<=895))&&((y>=600)&&(y<=640)))
        {
            outtextxy(745,610,"Hostel 16");
            return 29;
        }
        else if(((x>=705)&&(x<=895))&&((y>=640)&&(y<=680)))
        {
            outtextxy(745,650,"Hostel 6");
            return 30;
        }
        else if(((x>=905)&&(x<=1095))&&((y>=560)&&(y<=600)))
        {
            outtextxy(925,570,"Academic Area");
            return 31;
        }
        else if(((x>=905)&&(x<=1095))&&((y>=600)&&(y<=640)))
        {
            outtextxy(925,610,"SJM SOM");
            return 32;
        }
        else if(((x>=1105)&&(x<=1295))&&((y>=600)&&(y<=640)))
        {
            outtextxy(1125,610,"Infi Corridor");
            return 33;
        }
        else if(((x>=905)&&(x<=1095))&&((y>=640)&&(y<=680)))
        {
            outtextxy(745,690,"SBI");
            return 34;
        }
        else
        {
            goto L;
        }
    }
    else
    {
        goto L;
    }
    }
}

void initialize(Index A[10][10],int I1[29],int I2[6])//data for map stored in array for Index
{
    A[0][0].route=00;
    A[0][0].place="Forest";
    A[0][1].route=00;
    A[0][1].place="Forest";
    A[0][2].route=00;
    A[0][2].place="Forest";
    A[0][3].route=00;
    A[0][3].place="Forest";
    A[0][4].route=00;
    A[0][4].place="Forest";
    A[0][5].route=10;
    A[0][5].place="Hostel 16";
    A[0][6].route=11;
    A[0][6].place="Hostel 15";
    A[0][7].route=11;
    A[0][7].place="Ananta";
    A[0][8].route=11;
    A[0][8].place="Forest";
    A[0][9].route=00;
    A[0][9].place="Forest";
    A[1][0].route=00;
    A[1][0].place="Forest";
    A[1][1].route=10;
    A[1][1].place="Hostel 6";
    A[1][2].route=00;
    A[1][2].place="Tansa House";
    A[1][3].route=11;
    A[1][3].place="Hostel 4";
    A[1][4].route=11;
    A[1][4].place="Hostel 3";
    A[1][5].route=11;
    A[1][5].place="Hostel 2";
    A[1][6].route=11;
    A[1][6].place="Hostel 1";
    A[1][7].route=10;
    A[1][7].place="Forest";
    A[1][8].route=11;
    A[1][8].place="Vihar House";
    A[1][9].route=00;
    A[1][9].place="Forest";
    A[2][0].route=11;
    A[2][0].place="Hostel 12,13,14";
    A[2][1].route=11;
    A[2][1].place="Hostel 7";
    A[2][2].route=11;
    A[2][2].place="Hostel 9";
    A[2][3].route=11;
    A[2][3].place="Hostel 5";
    A[2][4].route=00;
    A[2][4].place="Football Ground";
    A[2][5].route=00;
    A[2][5].place="OAT";
    A[2][6].route=11;
    A[2][6].place="Forest";
    A[2][7].route=11;
    A[2][7].place="SysCon";
    A[2][8].route=11;
    A[2][8].place="UG Labs";
    A[2][9].route=00;
    A[2][9].place="Forest";
    A[3][0].route=00;
    A[3][0].place="Forest";
    A[3][1].route=00;
    A[3][1].place="Lake";
    A[3][2].route=00;
    A[3][2].place="Lake";
    A[3][3].route=11;
    A[3][3].place="Hostel 8";
    A[3][4].route=11;
    A[3][4].place="PHO";
    A[3][5].route=11;
    A[3][5].place="Hostel 11";
    A[3][6].route=11;
    A[3][6].place="CDEEP";
    A[3][7].route=10;
    A[3][7].place="Academic Area";
    A[3][8].route=11;
    A[3][8].place="Mech Workshop";
    A[3][9].route=00;
    A[3][9].place="Forest";
    A[4][0].route=00;
    A[4][0].place="Forest";
    A[4][1].route=00;
    A[4][1].place="Lake";
    A[4][2].route=00;
    A[4][2].place="Lake";
    A[4][3].route=11;
    A[4][3].place="Lake";
    A[4][4].route=11;
    A[4][4].place="Lake";
    A[4][5].route=00;
    A[4][5].place="Convocation Hall";
    A[4][6].route=11;
    A[4][6].place="Main Building";
    A[4][7].route=10;
    A[4][7].place="SOM";
    A[4][8].route=11;
    A[4][8].place="VMCC";
    A[4][9].route=11;
    A[4][9].place="Forest";
    A[5][0].route=00;
    A[5][0].place="Forest";
    A[5][1].route=00;
    A[5][1].place="Lake";
    A[5][2].route=00;
    A[5][2].place="Lake";
    A[5][3].route=00;
    A[5][3].place="Boat House";
    A[5][4].route=11;
    A[5][4].place="Lake";
    A[5][5].route=11;
    A[5][5].place="IIT Hospital";
    A[5][6].route=11;
    A[5][6].place="Gulmohar";
    A[5][7].route=00;
    A[5][7].place="KReSIT";
    A[5][8].route=10;
    A[5][8].place="Infi Corridor";
    A[5][9].route=11;
    A[5][9].place="Forest";
    A[6][0].route=00;
    A[6][0].place="Lake";
    A[6][1].route=00;
    A[6][1].place="Lake";
    A[6][2].route=00;
    A[6][2].place="Lake";
    A[6][3].route=00;
    A[6][3].place="Lake";
    A[6][4].route=00;
    A[6][4].place="Lake";
    A[6][5].route=11;
    A[6][5].place="Lake";
    A[6][6].route=11;
    A[6][6].place="Hostel 10";
    A[6][7].route=11;
    A[6][7].place="3 Pole Road";
    A[6][8].route=11;
    A[6][8].place="KV";
    A[6][9].route=11;
    A[6][9].place="YP Gate";
    A[7][0].route=00;
    A[7][0].place="Lake";
    A[7][1].route=00;
    A[7][1].place="Lake";
    A[7][2].route=00;
    A[7][2].place="Lake";
    A[7][3].route=00;
    A[7][3].place="Lake";
    A[7][4].route=00;
    A[7][4].place="Lake";
    A[7][5].route=11;
    A[7][5].place="Lake";
    A[7][6].route=11;
    A[7][6].place="Forest";
    A[7][7].route=11;
    A[7][7].place="Forest";
    A[7][8].route=00;
    A[7][8].place="IIT Campus School";
    A[7][9].route=00;
    A[7][9].place="Outside Campus";
    A[8][0].route=00;
    A[8][0].place="Lake";
    A[8][1].route=00;
    A[8][1].place="Lake";
    A[8][2].route=11;
    A[8][2].place="Devi Temple";
    A[8][3].route=00;
    A[8][3].place="Lake";
    A[8][4].route=00;
    A[8][4].place="Lake";
    A[8][5].route=11;
    A[8][5].place="Lake";
    A[8][6].route=10;
    A[8][6].place="SBI";
    A[8][7].route=11;
    A[8][7].place="Main Gate";
    A[8][8].route=00;
    A[8][8].place="Outside Campus";
    A[8][9].route=00;
    A[8][9].place="Outside Campus";
    A[9][0].route=00;
    A[9][0].place="Lake";
    A[9][1].route=00;
    A[9][1].place="Lake";
    A[9][2].route=11;
    A[9][2].place="Outside Campus";
    A[9][3].route=11;
    A[9][3].place="Lake Side Gate";
    A[9][4].route=11;
    A[9][4].place="Outside Campus";
    A[9][5].route=11;
    A[9][5].place="Outside Campus";
    A[9][6].route=00;
    A[9][6].place="Outside Campus";
    A[9][7].route=00;
    A[9][7].place="Outside Campus";
    A[9][8].route=00;
    A[9][8].place="Outside Campus";
    A[9][9].route=00;
    A[9][9].place="Outside Campus";
    I1[0]=16;//information regarding co-ordinates of important landmarks
    I1[1]=15;
    I1[2]=14;
    I1[3]=13;
    I1[4]=23;
    I1[5]=21;
    I1[6]=33;
    I1[7]=22;
    I1[8]=66;
    I1[9]=35;
    I1[10]=20;
    I1[11]=06;
    I1[12]=07;
    I1[13]=18;
    I1[14]=27;
    I1[15]=28;
    I1[16]=34;
    I1[17]=36;
    I1[18]=38;
    I1[19]=46;
    I1[20]=48;
    I1[21]=55;
    I1[22]=56;
    I1[23]=67;
    I1[24]=68;
    I1[25]=69;
    I1[26]=82;
    I1[27]=87;
    I1[28]=93;
    I2[0]=05;
    I2[1]=11;
    I2[2]=37;
    I2[3]=47;
    I2[4]=58;
    I2[5]=86;
    return;
}

int directions()//get directions
{
    Index Array[10][10];
    int IndexL1[29],IndexL2[6];
    initialize(Array,IndexL1,IndexL2);
    int x1,y1,x2,y2,c;
    int sol[10][10],visit[10][10];
    for(int i=0;i<10;i++)
    {
        for(int j=0;j<10;j++)
        {
            sol[i][j]=visit[i][j]=0;
        }
    }
    cleardevice();//input
    setcolor(2);
    rectangle(300,300,670,500);
    rectangle(700,300,1070,500);
    settextstyle(10,HORIZ_DIR,6);
    outtextxy(405,370,"Road");
    outtextxy(805,370,"Walk");

    setcolor(3);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");
    int x, y;        // Coordinates of the mouse click
    int divisor;

    Q : //Label to initiate mouse click again

    getmouseclick(WM_LBUTTONDOWN, x, y);

    if(((x>=300)&&(x<=670))&&((y>=300)&&(y<=500)))
    {
        c=0;
    }
    else
    if(((x>=700)&&(x<=1070))&&((y>=300)&&(y<=500)))
    {
        c=1;
    }
    else
        goto Q;

    cleardevice();
    setcolor(3);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");

    setcolor(2);
    settextstyle(2,HORIZ_DIR,8);
    outtextxy(230,165,"DIRECTIONS FROM :");
    int a=directions_from(c);

    setcolor(2);
    settextstyle(2,HORIZ_DIR,8);
    outtextxy(860,165,"DIRECTIONS TO :");
    int b=directions_to(c);

    setcolor(CYAN);
    settextstyle(2,HORIZ_DIR,60);
    outtextxy(1000,650,"Loading");
    delay(500);
    outtextxy(1000,650,"Loading .");
    delay(500);
    outtextxy(1000,650,"Loading . .");
    delay(500);
    outtextxy(1000,650,"Loading . . .");
    delay(500);

    if(c==0)
    {
        x1=IndexL1[a]/10;
        y1=IndexL1[a]%10;
        x2=IndexL1[b]/10;
        y2=IndexL1[b]%10;
    }
    else
    {
        if(a<29)
        {
            x1=IndexL1[a]/10;
            y1=IndexL1[a]%10;
        }
        else
        {
            x1=IndexL2[a-29]/10;
            y1=IndexL2[a-29]%10;
        }
        if(b<29)
        {
            x2=IndexL1[b]/10;
            y2=IndexL1[b]%10;
        }
        else
        {
            x2=IndexL2[b-29]/10;
            y2=IndexL2[b-29]%10;
        }
    }
    solveMaze(Array,x1,y1,sol,visit,x2,y2,c);//processing
    return printSolution(sol,x1,y1,x2,y2,Array);//output
}

bool isPossible(Index maze[10][10],int x,int y,int visit[10][10],int c)//checks if block is possible for path or not
{
    if(c==0)
    {
        if(x>=0 && x<10 && y>=0 && y<10 && visit[x][y]==0 && (maze[x][y].route)%10==1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    else
    {
        if(x>=0 && x<10 && y>=0 && y<10 && visit[x][y]==0 && (maze[x][y].route)/10==1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
}

bool solveMaze(Index maze[10][10],int x,int y,int sol[10][10],int visit[10][10],int x2,int y2,int c)//finds path in maze of 0 and 1 using recursion
{
    if(x == x2 && y == y2)
    {
        sol[x][y] = 1 ;
        return true;
    }

    if(isPossible(maze,x,y,visit,c))
    {
        sol[x][y] = 1;
        visit[x][y] = 1 ;
        int i,j;
        if(x>x2)
        {
            j=-1;
        }
        else
        {
            j=1;
        }
        if(y>y2)
        {
            i=-1;
        }
        else
        {
            i=1;
        }
        if(x==x2)
        {
            if(solveMaze(maze,x,y+i,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x+j,y,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x-j,y,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x,y-i,sol,visit,x2,y2,c))
                return true;
        }
        else if(y==y2)
        {
            if(solveMaze(maze,x+j,y,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x,y+i,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x,y-i,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x-j,y,sol,visit,x2,y2,c))
                return true;
        }
        else
        {
            if(solveMaze(maze,x,y+i,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x+j,y,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x,y-i,sol,visit,x2,y2,c))
                return true;
            if(solveMaze(maze,x-j,y,sol,visit,x2,y2,c))
                return true;
        }
        sol[x][y] = 0 ;
    }
    return false;
}

int printSolution(int sol[10][10],int x1,int y1,int x2,int y2,Index A[10][10])//prints solution in form of directions
{
    closegraph();
    initwindow(684,750,"Windows BGI",0,-20,FALSE,TRUE);

    setcolor(CYAN);
    settextstyle(6,HORIZ_DIR,4);
    if(x1==x2 && y1==y2)
    {
        outtextxy(10,15,"Congrats, You are already there");
    }
    else
    {
        int step=0,k=15;
        outtextxy(10,k,"Starting Point : ");
        char D1[25]={' '};
        memcpy(D1,A[x1][y1].place.c_str(),A[x1][y1].place.size());
        outtextxy(285,k,D1);
        k+=50;
        for (int i=x1,j=y1;;)
        {
            if(i==x1 && j==y1)
            {
                if(i<=8 && sol[i+1][j]==1)
                {
                    outtextxy(50,k,"Head Down");
                    k+=50;
                    step=2;
                    while(sol[i+1][j]==1&&i<=8)
                    {
                        i++;
                    }
                    if(i==x2 && j==y2)
                    {
                        break;
                    }
                }
                else if(j<=8 && sol[i][j+1]==1)
                {
                    outtextxy(50,k,"Head Right");
                    k+=50;
                    step=1;
                    while(sol[i][j+1]==1&&j<=8)
                    {
                        j++;
                    }
                    if(i==x2 && j==y2)
                    {
                        break;
                    }
                }
                else if(i>=1 && sol[i-1][j]==1)
                {
                    outtextxy(50,k,"Head Up");
                    k+=50;
                    step=4;
                    while(sol[i-1][j]==1&&i>=1)
                    {
                        i--;
                    }
                    if(i==x2 && j==y2)
                    {
                        break;
                    }
                }
                else if(j>=1 && sol[i][j-1]==1)
                {
                    outtextxy(50,k,"Head Left");
                    k+=50;
                    step=3;
                    while(sol[i][j-1]==1&&j>=1)
                    {
                        j--;
                    }
                    if(i==x2 && j==y2)
                    {
                        break;
                    }
                }
            }
            else
            {
                if(sol[i+1][j]==1&&i<=8&&step!=4)
                {
                    if(step==1)
                    {
                        outtextxy(50,k,"Turn Right at ");
                    }
                    else
                    {
                        outtextxy(50,k,"Turn Left  at ");
                    }
                    nearestLandmark(i,j,k,A);
                    k+=50;
                    step=2;
                    while(sol[i+1][j]==1&&i<=8)
                    {
                        i++;
                    }
                    if(i==x2 && j==y2)
                    {
                        break;
                    }
                }
                else if(sol[i][j+1]==1&&j<=8&&step!=3)
                {
                    if(step==4)
                    {
                        outtextxy(50,k,"Turn Right at ");
                    }
                    else
                    {
                        outtextxy(50,k,"Turn Left  at ");
                    }
                    nearestLandmark(i,j,k,A);
                    k+=50;
                    step=1;
                    while(sol[i][j+1]==1&&j<=8)
                    {
                        j++;
                    }
                    if(i==x2 && j==y2)
                    {
                        break;
                    }
                }
                else if(sol[i-1][j]==1&&i>=1&&step!=2)
                {
                    if(step==3)
                    {
                        outtextxy(50,k,"Turn Right at ");
                    }
                    else
                    {
                        outtextxy(50,k,"Turn Left  at ");
                    }
                    nearestLandmark(i,j,k,A);
                    k+=50;
                    step=4;
                    while(sol[i-1][j]==1&&i>=1)
                    {
                        i--;
                    }
                    if(i==x2 && j==y2)
                    {
                        break;
                    }
                }
                else if(sol[i][j-1]==1&&j>=1&&step!=1)
                {
                    if(step==2)
                    {
                        outtextxy(50,k,"Turn Right at ");
                    }
                    else
                    {
                        outtextxy(50,k,"Turn Left  at ");
                    }
                    nearestLandmark(i,j,k,A);
                    k+=50;
                    step=3;
                    while(sol[i][j-1]==1&&j>=1)
                    {
                        j--;
                    }
                    if(i==x2 && j==y2)
                    {
                        break;
                    }
                }
            }
        }
        outtextxy(10,k,"Ending  Point : ");
        char D2[25]={' '};
        memcpy(D2,A[x2][y2].place.c_str(),A[x2][y2].place.size());
        outtextxy(285,k,D2);
        setcolor(GREEN);
        settextstyle(4,HORIZ_DIR,2);
        outtextxy(10,650,"Perspective : Head-Map , Turn-Traveler");
    }
    setcolor(RED);
    settextstyle(6,HORIZ_DIR,3);
    outtextxy(10,500,"Press Enter to return to Main Menu");
    outtextxy(10,550,"Press Space Bar/Close either window to Exit");
    outtextxy(10,600,"Ensure Current window is Map");
    return load_image();
}

void nearestLandmark(int x, int y,int k,Index biitmap[10][10])//for printing directions
{
    if(!(biitmap[x][y].place=="Forest" || biitmap[x][y].place=="Lake" || biitmap[x][y].place=="Outside Campus"))
    {
        char D[25]={' '};
        memcpy(D,biitmap[x][y].place.c_str(),biitmap[x][y].place.size());
        outtextxy(305,k,D);
        return;
    }
    else if(x>=1)
    {
        if(!(biitmap[x-1][y].place=="Forest" || biitmap[x-1][y].place=="Lake" || biitmap[x-1][y].place=="Outside Campus"))
        {
            char D[25]={' '};
            memcpy(D,biitmap[x-1][y].place.c_str(),biitmap[x-1][y].place.size());
            outtextxy(305,k,D);
            return;
        }
    }
        else if(y<=8)
    {
        if(!(biitmap[x][y+1].place=="Forest" || biitmap[x][y+1].place=="Lake" || biitmap[x][y+1].place=="Outside Campus"))
        {
            char D[25]={' '};
            memcpy(D,biitmap[x][y+1].place.c_str(),biitmap[x][y+1].place.size());
            outtextxy(305,k,D);
            return;
        }
    }
    else if(x<=8)
    {
        if(!(biitmap[x+1][y].place=="Forest" || biitmap[x+1][y].place=="Lake" || biitmap[x+1][y].place=="Outside Campus"))
        {
            char D[25]={' '};
            memcpy(D,biitmap[x+1][y].place.c_str(),biitmap[x+1][y].place.size());
            outtextxy(305,k,D);
            return;
        }
    }
    else if(y>=1)
    {
        if(!(biitmap[x][y-1].place=="Forest" || biitmap[x][y-1].place=="Lake" || biitmap[x][y-1].place=="Outside Campus"))
        {
            char D[25]={' '};
            memcpy(D,biitmap[x][y-1].place.c_str(),biitmap[x][y-1].place.size());
            outtextxy(305,k,D);
            return;
        }
    }
    int i,j,counter=0,p=1,check=0;
    while(true)
    {
        //loop part1
        i=x-p;
        if(i>=0)
        {
            for (j=y-p;j<y+p;j++)
            {
                //scanner
                 if(j>=0&&j<=9)
                 {
                     if(!(biitmap[i][j].place=="Forest" || biitmap[i][j].place=="Lake" || biitmap[i][j].place=="Outside Campus"))
                     {
                        counter++;
                        char D[25]={' '};
                        memcpy(D,biitmap[i][j].place.c_str(),biitmap[i][j].place.size());
                        outtextxy(305,k,D);
                        if(counter==1)
                        {
                            check=1;
                            break;
                        }
                     }
                 }
             }
        }
        if(check==1)
        {
            break;
        }
		//loop part2
		j=y+p;
        if(j<=9)
        {
            for (i=x-p;i<x+p;i++)
            {
                //scanner
                 if(i>=0&&i<=9)
                 {
                     if(!(biitmap[i][j].place=="Forest" || biitmap[i][j].place=="Lake" || biitmap[i][j].place=="Outside Campus"))
                     {
                        counter++;
                        char D[25]={' '};
                        memcpy(D,biitmap[i][j].place.c_str(),biitmap[i][j].place.size());
                        outtextxy(305,k,D);
                        if(counter==1)
                        {
                            check=1;
                            break;
                        }
                     }
                 }
             }
        }
        if(check==1)
        {
            break;
        }
        //loop part3
		i=x+p;
        if(i<=9)
        {
            for (j=y+p;j>y-p;j--)
            {
                //scanner
                 if(j>=0&&j<=9)
                 {
                     if(!(biitmap[i][j].place=="Forest" || biitmap[i][j].place=="Lake" || biitmap[i][j].place=="Outside Campus"))
                     {
                        counter++;
                        char D[25]={' '};
                        memcpy(D,biitmap[i][j].place.c_str(),biitmap[i][j].place.size());
                        outtextxy(305,k,D);
                        if(counter==1)
                        {
                            check=1;
                            break;
                        }
                     }
                 }
             }
        }
        if(check==1)
        {
            break;
        }
        //loop part4
		j=y-p;
        if(j>=0)
        {
            for (i=x+p;i>x-p;i--)
            {
                //scanner
                 if(i>=0&&i<=9)
                 {
                     if(!(biitmap[i][j].place=="Forest" || biitmap[i][j].place=="Lake" || biitmap[i][j].place=="Outside Campus"))
                     {
                        counter++;
                        char D[25]={' '};
                        memcpy(D,biitmap[i][j].place.c_str(),biitmap[i][j].place.size());
                        outtextxy(305,k,D);
                        if(counter==1)
                        {
                            check=1;
                            break;
                        }
                     }
                 }
             }
        }
        if(check==1)
        {
            break;
        }
        p++;
    }
    return;

//lake outside and forest is not landmark

}

int nearestLandmarks(int x, int y,Index biitmap[10][10])//finds 3 nearest landmarks
{
    closegraph();
    initwindow(684,750,"Windows BGI",0,-20,FALSE,TRUE);

    setcolor(CYAN);
    settextstyle(6,HORIZ_DIR,4);
    int i,j,counter=0,p=1,check=0,k=15;

    outtextxy(10,k,"Location :");
    k+=50;
    char D1[25]={' '};
    memcpy(D1,biitmap[x][y].place.c_str(),biitmap[x][y].place.size());
    outtextxy(10,k,D1);
    k+=80;

    outtextxy(10,k,"Nearest Landmarks:");
    k+=50;
    while(true)
    {
        //loop part1
        i=x-p;
        if(i>=0)
        {
            for (j=y-p;j<y+p;j++)
            {
                //scanner
                 if(j>=0&&j<=9)
                 {
                     if(!(biitmap[i][j].place=="Forest" || biitmap[i][j].place=="Lake" || biitmap[i][j].place=="Outside Campus"))
                     {
                        counter++;
                        char D[25]={' '};
                        memcpy(D,biitmap[i][j].place.c_str(),biitmap[i][j].place.size());
                        outtextxy(10,k,D);
                        k+=50;
                        if(counter==3)
                        {
                            check=1;
                            break;
                        }
                     }
                 }
             }
        }
        if(check==1)
        {
            break;
        }
		//loop part2
		j=y+p;
        if(j<=9)
        {
            for (i=x-p;i<x+p;i++)
            {
                //scanner
                 if(i>=0&&i<=9)
                 {
                     if(!(biitmap[i][j].place=="Forest" || biitmap[i][j].place=="Lake" || biitmap[i][j].place=="Outside Campus"))
                     {
                        counter++;
                        char D[25]={' '};
                        memcpy(D,biitmap[i][j].place.c_str(),biitmap[i][j].place.size());
                        outtextxy(10,k,D);
                        k+=50;
                        if(counter==3)
                        {
                            check=1;
                            break;
                        }
                     }
                 }
             }
        }
        if(check==1)
        {
            break;
        }
        //loop part3
		i=x+p;
        if(i<=9)
        {
            for (j=y+p;j>y-p;j--)
            {
                //scanner
                 if(j>=0&&j<=9)
                 {
                     if(!(biitmap[i][j].place=="Forest" || biitmap[i][j].place=="Lake" || biitmap[i][j].place=="Outside Campus"))
                     {
                        counter++;
                        char D[25]={' '};
                        memcpy(D,biitmap[i][j].place.c_str(),biitmap[i][j].place.size());
                        outtextxy(10,k,D);
                        k+=50;
                        if(counter==3)
                        {
                            check=1;
                            break;
                        }
                     }
                 }
             }
        }
        if(check==1)
        {
            break;
        }
        //loop part4
		j=y-p;
        if(j>=0)
        {
            for (i=x+p;i>x-p;i--)
            {
                //scanner
                 if(i>=0&&i<=9)
                 {
                     if(!(biitmap[i][j].place=="Forest" || biitmap[i][j].place=="Lake" || biitmap[i][j].place=="Outside Campus"))
                     {
                        counter++;
                        char D[25]={' '};
                        memcpy(D,biitmap[i][j].place.c_str(),biitmap[i][j].place.size());
                        outtextxy(10,k,D);
                        k+=50;
                        if(counter==3)
                        {
                            check=1;
                            break;
                        }
                     }
                 }
             }
        }
        if(check==1)
        {
            break;
        }
        p++;
    }
    setcolor(RED);
    settextstyle(6,HORIZ_DIR,3);
    outtextxy(10,500,"Press Enter to return to Main Menu");
    outtextxy(10,550,"Press Space Bar/Close either window to Exit");
    outtextxy(10,600,"Ensure Current window is Map");
    return load_image();

//lake outside and forest is not landmark

}

int load_image()//displays map stored as .bmp file
{
    int a;
    CImg<unsigned char> image("mapfinal.bmp");
    CImgDisplay main_disp(image,"MAP");
    main_disp.move(684,10);
    while (!(main_disp.is_closed()||main_disp.is_keyENTER()||main_disp.is_keySPACE()))
    {
        main_disp.wait();
    }
    if(main_disp.is_keyENTER())
    {
        a=1;
    }
    else
    {
        a=0;
    }
    main_disp.close();
    closegraph();
    return a;
}

int nearest()//finds 3 nearest landmarks, after taking input
{
    Index Array[10][10];
    int IndexL1[29],IndexL2[6];
    initialize(Array,IndexL1,IndexL2);
    int x,y;

    cleardevice();//input
    setcolor(3);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");

    setcolor(2);
    settextstyle(2,HORIZ_DIR,8);
    outtextxy(240,165,"Location :");
    int a=directions_from(1);

    setcolor(CYAN);
    settextstyle(2,HORIZ_DIR,60);
    outtextxy(1000,650,"Loading");
    delay(500);
    outtextxy(1000,650,"Loading .");
    delay(500);
    outtextxy(1000,650,"Loading . .");
    delay(500);
    outtextxy(1000,650,"Loading . . .");
    delay(500);

    if(a<29)//processing
    {
        x=IndexL1[a]/10;
        y=IndexL1[a]%10;
    }
    else
    {
        x=IndexL2[a-29]/10;
        y=IndexL2[a-29]%10;
    }
    return nearestLandmarks(x,y,Array);//output
}

int rel()//finds relative direction and distance
{
    Index Array[10][10];
    int IndexL1[29],IndexL2[6];
    initialize(Array,IndexL1,IndexL2);
    int x,y,x2,y2;

    cleardevice();//input
    setcolor(3);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");

    setcolor(2);
    settextstyle(2,HORIZ_DIR,8);
    outtextxy(230,165,"Starting Point :");
    int a=directions_from(1);

    setcolor(2);
    settextstyle(2,HORIZ_DIR,8);
    outtextxy(860,165,"Ending Point :");
    int b=directions_to(1);

    setcolor(CYAN);
    settextstyle(2,HORIZ_DIR,60);
    outtextxy(1000,650,"Loading");
    delay(500);
    outtextxy(1000,650,"Loading .");
    delay(500);
    outtextxy(1000,650,"Loading . .");
    delay(500);
    outtextxy(1000,650,"Loading . . .");
    delay(500);

    if(a<29)//processing
    {
        x=IndexL1[a]/10;
        y=IndexL1[a]%10;
    }
    else
    {
        x=IndexL2[a-29]/10;
        y=IndexL2[a-29]%10;
    }
    if(b<29)
    {
        x2=IndexL1[b]/10;
        y2=IndexL1[b]%10;
    }
    else
    {
        x2=IndexL2[b-29]/10;
        y2=IndexL2[b-29]%10;
    }
    return relative(x,y,x2,y2,Array);//output
}

int relative(int x1,int y1,int x2,int y2,Index A[10][10])//input and output for relative locations
{
    closegraph();
    initwindow(684,750,"Windows BGI",0,-20,FALSE,TRUE);

    setcolor(CYAN);
    settextstyle(6,HORIZ_DIR,4);

    outtextxy(10,15,"Starting Point : ");
    char D1[25]={' '};
    memcpy(D1,A[x1][y1].place.c_str(),A[x1][y1].place.size());
    outtextxy(285,15,D1);
    outtextxy(10,65,"Ending  Point : ");
    char D2[25]={' '};
    memcpy(D2,A[x2][y2].place.c_str(),A[x2][y2].place.size());
    outtextxy(285,65,D2);
    if(x1==x2 && y1==y2)
    {
        outtextxy(10,225,"Same Place");
    }
    else
    {
        outtextxy(10,225,"Direction : ");
        if(x1==x2)
        {
            if(y1<y2)
            {
                outtextxy(215,225,"East");
            }
            else
            {
                outtextxy(215,225,"West");
            }
        }
        else if(y1==y2)
        {
            if(x1<x2)
            {
                outtextxy(215,225,"South");
            }
            else
            {
                outtextxy(215,225,"North");
            }
        }
        else
        {
            if(x1<x2)
            {
                if(y1<y2)
                {
                    outtextxy(215,225,"South-East");
                }
                else
                {
                    outtextxy(215,225,"South-West");
                }
            }
            else
            {
                if(y1<y2)
                {
                    outtextxy(215,225,"North-East");
                }
                else
                {
                    outtextxy(215,225,"North-West");
                }
            }
        }
    }
    double x=x1-x2;
    double y=y1-y2;
    double d1=(abs(x)+0.5)*(abs(x)+0.5)+(abs(y)+0.5)*(abs(y)+0.5);
    double d2=sqrt(d1);
    int d3=(int)d2;
    outtextxy(10,385,"Approximate Distance ( in m ) : ");
    stringstream ss;
    ss << (d3*350);
    string s = ss.str();
    char D3[25]={' '};
    memcpy(D3,s.c_str(),s.size());
    outtextxy(585,385,D3);

    setcolor(RED);
    settextstyle(6,HORIZ_DIR,3);
    outtextxy(10,500,"Press Enter to return to Main Menu");
    outtextxy(10,550,"Press Space Bar/Close either window to Exit");
    outtextxy(10,600,"Ensure Current window is Map");
    return load_image();
}

int tumtum_from()//input starting point for tumtums
{

    setcolor(2);
    rectangle(75,200,265,240);
    rectangle(75,240,265,280);
    rectangle(75,280,265,320);
    rectangle(75,320,265,360);
    rectangle(75,360,265,400);
    rectangle(75,400,265,440);
    rectangle(75,440,265,480);
    rectangle(75,480,265,520);
    rectangle(75,520,265,560);

    rectangle(275,200,465,240);
    rectangle(275,240,465,280);
    rectangle(275,280,465,320);
    rectangle(275,320,465,360);
    rectangle(275,360,465,400);
    rectangle(275,400,465,440);
    rectangle(275,440,465,480);
    rectangle(275,480,465,520);

    rectangle(475,200,665,240);
    rectangle(475,240,665,280);
    rectangle(475,280,665,320);
    rectangle(475,320,665,360);
    rectangle(475,360,665,400);
    rectangle(475,400,665,440);
    rectangle(475,440,665,480);
    rectangle(475,480,665,520);

    setcolor(3);
    settextstyle(10,HORIZ_DIR,2);
    outtextxy(115,210,"Hostel 1");
    outtextxy(115,250,"Hostel 2");
    outtextxy(115,290,"Hostel 3");
    outtextxy(115,330,"Hostel 4");
    outtextxy(115,370,"Hostel 5");
    outtextxy(115,410,"Hostel 6");
    outtextxy(115,450,"Hostel 7");
    outtextxy(115,490,"Hostel 8");
    outtextxy(115,530,"Hostel 9");

    outtextxy(295,210,"Hostel 10");
    outtextxy(295,250,"Hostel 11");
    outtextxy(280,290,"Hostel 12,13,14");
    outtextxy(295,330,"Hostel 15");
    outtextxy(295,370,"Hostel 16");
    outtextxy(295,410,"Vihar House");
    outtextxy(295,450,"Sameer Hill");
    outtextxy(295,490,"VMCC");

    outtextxy(495,210,"Main Building");
    outtextxy(495,250,"SJM SOM");
    outtextxy(495,290,"KReSIT");
    outtextxy(495,330,"Main Gate");
    outtextxy(495,370,"YP Gate");
    outtextxy(495,410,"Lake Side");
    outtextxy(495,450,"KV,IIT Powai");
    outtextxy(495,490,"Hill Side");

    int x, y;        // Coordinates of the mouse click
    int divisor;

    P : //Label to initiate mouse click again

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y
    setcolor(RED);
    if(((x>=75)&&(x<=265))&&((y>=200)&&(y<=240)))
    {
        outtextxy(115,210,"Hostel 1");
        return 2601;
    }else
    if(((x>=75)&&(x<=265))&&((y>=240)&&(y<=280)))
    {
        outtextxy(115,250,"Hostel 2");
        return 2602;
    }else
    if(((x>=75)&&(x<=265))&&((y>=280)&&(y<=320)))
    {
        outtextxy(115,290,"Hostel 3");
        return 2603;
    }else
    if(((x>=75)&&(x<=265))&&((y>=320)&&(y<=360)))
    {
        outtextxy(115,330,"Hostel 4");
        return 2604;
    }else
    if(((x>=75)&&(x<=265))&&((y>=360)&&(y<=400)))
    {
        outtextxy(115,370,"Hostel 5");
        return 2605;
    }else
    if(((x>=75)&&(x<=265))&&((y>=400)&&(y<=440)))
    {
        outtextxy(115,410,"Hostel 6");
        return 2606;
    }else
    if(((x>=75)&&(x<=265))&&((y>=440)&&(y<=480)))
    {
        outtextxy(115,450,"Hostel 7");
        return 2607;
    }else
    if(((x>=75)&&(x<=265))&&((y>=480)&&(y<=520)))
    {
        outtextxy(115,490,"Hostel 8");
        return 2608;
    }else
    if(((x>=75)&&(x<=265))&&((y>=520)&&(y<=560)))
    {
        outtextxy(115,530,"Hostel 9");
        return 2609;
    }else
    if(((x>=275)&&(x<=465))&&((y>=200)&&(y<=240)))
    {
        outtextxy(295,210,"Hostel 10");
        return 2610;
    }else
    if(((x>=275)&&(x<=465))&&((y>=240)&&(y<=280)))
    {
        outtextxy(295,250,"Hostel 11");
        return 2611;
    }else
    if(((x>=275)&&(x<=465))&&((y>=280)&&(y<=320)))
    {
        outtextxy(280,290,"Hostel 12,13,14");
        return 2612;
    }else
    if(((x>=275)&&(x<=465))&&((y>=320)&&(y<=360)))
    {
        outtextxy(295,330,"Hostel 15");
        return 2615;
    }else
    if(((x>=275)&&(x<=465))&&((y>=360)&&(y<=400)))
    {
        outtextxy(295,370,"Hostel 16");
        return 2616;
    }else
    if(((x>=275)&&(x<=465))&&((y>=400)&&(y<=440)))
    {
        outtextxy(295,410,"Vihar House");
        return 2705;
    }else
    if(((x>=275)&&(x<=465))&&((y>=440)&&(y<=480)))
    {
        outtextxy(295,450,"Sameer Hill");
        return 2702;
    }else
    if(((x>=275)&&(x<=465))&&((y>=480)&&(y<=520)))
    {
        outtextxy(295,490,"VMCC");
        return 2621;
    }else
    if(((x>=475)&&(x<=665))&&((y>=200)&&(y<=240)))
    {
        outtextxy(495,210,"Main Building");
        return 2502;
    }else
    if(((x>=475)&&(x<=665))&&((y>=240)&&(y<=280)))
    {
        outtextxy(495,250,"SJM SOM");
        return 2620;
    }else
    if(((x>=475)&&(x<=665))&&((y>=280)&&(y<=320)))
    {
        outtextxy(495,290,"KReSIT");
        return 2501;
    }else
    if(((x>=475)&&(x<=665))&&((y>=320)&&(y<=360)))
    {
        outtextxy(495,330,"Main Gate");
        return 2600;
    }else
    if(((x>=475)&&(x<=665))&&((y>=360)&&(y<=400)))
    {
        outtextxy(495,370,"YP Gate");
        return 2699;
    }else
    if(((x>=475)&&(x<=665))&&((y>=400)&&(y<=440)))
    {
        outtextxy(495,410,"Lake Side");
        return 2403;
    }else
    if(((x>=475)&&(x<=665))&&((y>=440)&&(y<=480)))
    {
        outtextxy(495,450,"KV,IIT Powai");
        return 2707;
    }else
    if(((x>=475)&&(x<=665))&&((y>=480)&&(y<=520)))
    {
        outtextxy(495,490,"Hill Side");
        return 2703;
    }else
    {
        goto P;
    }
}

int tumtum_to()//input ending point for tumtums
{

    setcolor(2);
    rectangle(705,200,895,240);
    rectangle(705,240,895,280);
    rectangle(705,280,895,320);
    rectangle(705,320,895,360);
    rectangle(705,360,895,400);
    rectangle(705,400,895,440);
    rectangle(705,440,895,480);
    rectangle(705,480,895,520);
    rectangle(705,520,895,560);

    rectangle(905,200,1095,240);
    rectangle(905,240,1095,280);
    rectangle(905,280,1095,320);
    rectangle(905,320,1095,360);
    rectangle(905,360,1095,400);
    rectangle(905,400,1095,440);
    rectangle(905,440,1095,480);
    rectangle(905,480,1095,520);

    rectangle(1105,200,1295,240);
    rectangle(1105,240,1295,280);
    rectangle(1105,280,1295,320);
    rectangle(1105,320,1295,360);
    rectangle(1105,360,1295,400);
    rectangle(1105,400,1295,440);
    rectangle(1105,440,1295,480);
    rectangle(1105,480,1295,520);

    setcolor(3);
    settextstyle(10,HORIZ_DIR,2);
    outtextxy(745,210,"Hostel 1");
    outtextxy(745,250,"Hostel 2");
    outtextxy(745,290,"Hostel 3");
    outtextxy(745,330,"Hostel 4");
    outtextxy(745,370,"Hostel 5");
    outtextxy(745,410,"Hostel 6");
    outtextxy(745,450,"Hostel 7");
    outtextxy(745,490,"Hostel 8");
    outtextxy(745,530,"Hostel 9");

    outtextxy(925,210,"Hostel 10");
    outtextxy(925,250,"Hostel 11");
    outtextxy(910,290,"Hostel 12,13,14");
    outtextxy(925,330,"Hostel 15");
    outtextxy(925,370,"Hostel 16");
    outtextxy(925,410,"Vihar House");
    outtextxy(925,450,"Sameer Hill");
    outtextxy(925,490,"VMCC");

    outtextxy(1125,210,"Main Building");
    outtextxy(1125,250,"SJM SOM");
    outtextxy(1125,290,"KReSIT");
    outtextxy(1125,330,"Main Gate");
    outtextxy(1125,370,"YP Gate");
    outtextxy(1125,410,"Lake Side");
    outtextxy(1125,450,"KV,IIT Powai");
    outtextxy(1125,490,"Hill Side");

    int x, y;        // Coordinates of the mouse click
    int divisor;

    P : //Label to initiate mouse click again

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y
    setcolor(RED);
    if(((x>=705)&&(x<=895))&&((y>=200)&&(y<=240)))
    {
        outtextxy(745,210,"Hostel 1");
        return 2601;
    }else
    if(((x>=705)&&(x<=895))&&((y>=240)&&(y<=280)))
    {
        outtextxy(745,250,"Hostel 2");
        return 2602;
    }else
    if(((x>=705)&&(x<=895))&&((y>=280)&&(y<=320)))
    {
        outtextxy(745,290,"Hostel 3");
        return 2603;
    }else
    if(((x>=705)&&(x<=895))&&((y>=320)&&(y<=360)))
    {
        outtextxy(745,330,"Hostel 4");
        return 2604;
    }else
    if(((x>=705)&&(x<=895))&&((y>=360)&&(y<=400)))
    {
        outtextxy(745,370,"Hostel 5");
        return 2605;
    }else
    if(((x>=705)&&(x<=895))&&((y>=400)&&(y<=440)))
    {
        outtextxy(745,410,"Hostel 6");
        return 2606;
    }else
    if(((x>=705)&&(x<=895))&&((y>=440)&&(y<=480)))
    {
        outtextxy(745,450,"Hostel 7");
        return 2607;
    }else
    if(((x>=705)&&(x<=895))&&((y>=480)&&(y<=520)))
    {
        outtextxy(745,490,"Hostel 8");
        return 2608;
    }else
    if(((x>=705)&&(x<=895))&&((y>=520)&&(y<=560)))
    {
        outtextxy(745,530,"Hostel 9");
        return 2609;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=200)&&(y<=240)))
    {
        outtextxy(925,210,"Hostel 10");
        return 2610;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=240)&&(y<=280)))
    {
        outtextxy(925,250,"Hostel 11");
        return 2611;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=280)&&(y<=320)))
    {
        outtextxy(910,290,"Hostel 12,13,14");
        return 2612;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=320)&&(y<=360)))
    {
        outtextxy(925,330,"Hostel 15");
        return 2615;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=360)&&(y<=400)))
    {
        outtextxy(925,370,"Hostel 16");
        return 2616;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=400)&&(y<=440)))
    {
        outtextxy(925,410,"Vihar House");
        return 2705;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=440)&&(y<=480)))
    {
        outtextxy(925,450,"Sameer Hill");
        return 2702;
    }else
    if(((x>=905)&&(x<=1095))&&((y>=480)&&(y<=520)))
    {
        outtextxy(925,490,"VMCC");
        return 2621;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=200)&&(y<=240)))
    {
        outtextxy(1125,210,"Main Building");
        return 2502;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=240)&&(y<=280)))
    {
        outtextxy(1125,250,"SJM SOM");
        return 2620;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=280)&&(y<=320)))
    {
        outtextxy(1125,290,"KReSIT");
        return 2501;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=320)&&(y<=360)))
    {
        outtextxy(1125,330,"Main Gate");
        return 2600;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=360)&&(y<=400)))
    {
        outtextxy(1125,370,"YP Gate");
        return 2699;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=400)&&(y<=440)))
    {
        outtextxy(1125,410,"Lake Side");
        return 2403;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=440)&&(y<=480)))
    {
        outtextxy(1125,450,"KV,IIT Powai");
        return 2707;
    }else
    if(((x>=1105)&&(x<=1295))&&((y>=480)&&(y<=520)))
    {
        outtextxy(1125,490,"Hill Side");
        return 2703;
    }else
    {
        goto P;
    }
}

int tumtum()//processing and output for tumtum option
{
    string entry;
    int HHMM;

    bool boolRoutes[10] = {false};

    int routes[10][25] = {{2600,2610,2501,2620,2502,2611,2608,2609,2607,2606,2612,2605,2604,2603,2602,2601,2615,2616,2702,2703,2705,2621,2706,2699,0},
                           {2699,2706,2621,2705,2703,2702,2616,2615,2601,2602,2603,2604,2605,2609,2607,2606,2612,2608,2611,2502,2620,2501,2610,2600,0},
                           {2612,2606,2607,2609,2608,2611,2502,2620,2501,2610,2600,2610,2501,2620,2502,2601,2602,2603,2604,2605,2609,2607,2606,2612,0},
                           {2612,2606,2607,2609,2605,2604,2603,2602,2601,2502,2620,2501,2610,2600,2610,2501,2620,2502,2611,2608,2609,2607,2606,2612,0},
                           {2612,2606,2607,2609,2608,2611,2502,2620,2501,2610,2706,2699,2610,2501,2620,2502,2601,2602,2603,2604,2605,2609,2607,2606,2612},
                           {2403,2620,2502,2611,2608,2609,2607,2612,2605,2604,2603,2602,2601,2615,2616,2702,2703,2705,2621,2706,2699,2610,2600,2403,0},
                           {2403,2600,2610,2699,2706,2621,2705,2703,2702,2616,2615,2601,2602,2603,2604,2605,2612,2607,2609,2608,2611,2502,2620,2403,0},
                           {2612,2606,2607,2609,2608,2611,2502,2620,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                           {2605,2604,2603,2602,2601,2502,2620,2502,2611,2608,2605,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
                           {2605,2608,2611,2502,2620,2502,2601,2602,2603,2604,2605,0,0,0,0,0,0,0,0,0,0,0,0,0,0} };

    int timeRoute1A [34] =
        {640,700,720,745,815,845,915,945,1015,1045,1115,1145,1215,1245,1315,1345,1415,1445,1515,1545,1615,1645,1715,1745,1815,1845,1915,1945,2015,2045,2115,2145,2215,9999};

    int timeRoute1B[31] =
        {745,815,845,915,945,1015,1045,1115,1145,1215,1245,1315,1345,1415,1445,1515,1545,1615,1645,1715,1745,1815,1845,1915,1945,2015,2045,2115,2145,2215,9999};

    int timeRoute2A[50] =
        {700,720,740,800,820,840,900,920,940,1000,1020,1040,1100,1120,1140,1200,1220,1240,1300,1320,1340,1400,1420,1440,1500,1520,1540,1600,1620,1640,1700,1720,1740,1800,1820,1840,1900,1920,1940,2000,2020,2040,2100,2120,2140,2200,2220,2240,2300,9999};

    int timeRoute2A1[49] =
        {710,730,750,810,830,850,910,930,950,1010,1030,1050,1110,1130,1150,1210,1230,1250,1310,1330,1350,1410,1430,1450,1510,1530,1550,1610,1630,1650,1710,1730,1750,1810,1830,1850,1910,1930,1950,2010,2030,2050,2110,2130,2150,2210,2230,2250,9999};

    int timeRoute2B[46] =
        {715,735,755,815,835,855,915,935,955,1015,1035,1055,1115,1135,1155,1215,1235,1255,1315,1335,1355,1415,1435,1455,1515,1535,1555,1615,1635,1655,1715,1735,1755,1815,1835,1855,1915,1935,1955,2015,2035,2055,2115,2135,2155,9999};

    int timeRoute3A[33] =
        {715,0745,815,845,915,945,1015,1045,1115,1145,1215,1245,1315,1345,1415,1445,1515,1545,1615,1645,1715,1745,1815,1845,1915,1945,2015,2045,2115,2145,2215,2245,9999};

    int timeRoute3B[33] =
        {700,730,800,830,900,930,1000,1030,1100,1130,1200,1230,1300,1330,1400,1430,1500,1530,1600,1630,1700,1730,1800,1830,1900,1930,2000,2030,2100,2130,2200,2230,9999};

    int timeRoute4A[30] =
        {1030,1040,1050,1100,1110,1120,1230,1430,1440,1450,1500,1510,1520,1530,1540,1550,1600,1810,1820,1830,1840,1850,1900,1910,1920,1930,1940,1950,9999};

    int timeRoute5A[30] =
        {1030,1040,1050,1100,1110,1120,1230,1430,1440,1450,1500,1510,1520,1530,1540,1550,1600,1810,1820,1830,1840,1850,1900,1910,1920,1930,1940,1950,9999};

    int timeRoute5B[28] =
        {1130,1140,1150,1200,1210,1220,1440,1450,1500,1510,1520,1600,1610,1620,1630,1800,1815,1825,1835,1845,1855,1905,1915,1925,1935,1945,9999};

    int start1,end1;
    cleardevice();
    setcolor(3);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");

    setcolor(2);
    settextstyle(2,HORIZ_DIR,8);
    outtextxy(280,165,"Starting Point :");
    start1=tumtum_from();

    setcolor(2);
    settextstyle(2,HORIZ_DIR,8);
    outtextxy(915,165,"Ending Point :");
    end1=tumtum_to();

    setcolor(CYAN);
    settextstyle(2,HORIZ_DIR,60);
    outtextxy(1000,650,"Loading");
    delay(500);
    outtextxy(1000,650,"Loading .");
    delay(500);
    outtextxy(1000,650,"Loading . .");
    delay(500);
    outtextxy(1000,650,"Loading . . .");
    delay(500);
    if(start1==end1)
    {
        cleardevice();
        outtextxy(10,15,"Congrats, You are already there");
    }
    else
    {
        int i=0,j=0,h=0,flag=0;
//search place 1 in all arrays one by one
    for(h=0; h<10; h++)
    {
        if(h==0||h==1||h==7)
            flag=1;
        else
            flag=0;
        i=0;
        do
        {
            if (routes[h][i] == start1)
            {
                if(flag==1)
                    j=0;
                else
                    j=i;
                do
                {
                    if (routes[h][j] == end1)
                    {
                        boolRoutes[h]=true;
                        break;
                    }
                    j++;
                }while(routes[h][j]!=0&&j<25);
                break;
            }
            i++;
        }while(routes[h][i]!=0&&i<25);
    }

    cleardevice();
    setcolor(3);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");
    setcolor(CYAN);
    settextstyle(6,HORIZ_DIR,4);
    outtextxy(570,250,"Time Input");
    setcolor(2);
    rectangle(450,300,660,380);
    rectangle(680,300,890,380);

    setcolor(3);
    settextstyle(10,HORIZ_DIR,4);
    outtextxy(485,323,"Current");
    outtextxy(710,323,"Specific");

    int x, y;        // Coordinates of the mouse click
    int divisor;

    P : //Label to initiate mouse click again

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y
    setcolor(RED);
    if(((x>=450)&&(x<=660))&&((y>=300)&&(y<=380)))
    {
        outtextxy(485,323,"Current");
        time_t now = time(0);
        char* dt = ctime(&now);
        HHMM=((dt[11]-48)*1000)+((dt[12]-48)*100)+((dt[14]-48)*10)+(dt[15]-48);
    }
    else if(((x>=680)&&(x<=890))&&((y>=300)&&(y<=380)))
    {
        outtextxy(710,323,"Specific");
        HHMM=tumtum_time();
    }
    else
    {
        goto P;
    }

    cleardevice();
    setcolor(CYAN);
    settextstyle(6,HORIZ_DIR,1);
    int w=10,k,check=0,cool=0;
    h=15;

    if (boolRoutes[0]==true)
    {
        for(k=0; timeRoute1A[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute1A[k])
                {
                    check++;
                    outtextxy(w,h,"1A : Main Gate > SOM > Hostel 8 > Hostel 12 > Hostel 5 > Hostel 1 > Hill Side > IDC > YP Gate");
                    h+=20;
                    outtextxy(w,h,"> IDC > Hill Side > Hostel 1 > Hostel 5 > Hostel 12 > Hostel 8 > SOM > Main Gate");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute1A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute1A[k])
                {
                    stringstream ss;
                    ss << timeRoute1A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[1]==true)
    {
        for(k=0; timeRoute1B[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute1B[k])
                {
                    check++;
                    outtextxy(w,h,"1B : YP Gate > IDC > Hill Side > Hostel 1 > Hostel 5 > Hostel 12 > Hostel 8 > SOM > Main Gate");
                    h+=20;
                    outtextxy(w,h,"> SOM > Hostel 8 > Hostel 12 > Hostel 5 > Hostel 1 > Hill Side > IDC > YP Gate");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute1B[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute1B[k])
                {
                    stringstream ss;
                    ss << timeRoute1B[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[2]==true)
    {
        for(k=0; timeRoute2A[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute2A[k])
                {
                    check++;
                    outtextxy(w,h,"2A1 : Hostel 12 > Hostel 8 > SOM > Main Gate > SOM > Hostel 1 > Hostel 5 > Hostel 12");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute2A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute2A[k])
                {
                    stringstream ss;
                    ss << timeRoute2A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[3]==true)
    {
        for(k=0; timeRoute2A1[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute2A1[k])
                {
                    check++;
                    outtextxy(w,h,"2A2 : Hostel 12 > Hostel 5 > Hostel 1 > SOM > Main Gate > SOM > Hostel 8 > Hostel 12");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute2A1[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute2A1[k])
                {
                    stringstream ss;
                    ss << timeRoute2A1[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[4]==true)
    {
        for(k=0; timeRoute2B[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute2B[k])
                {
                    check++;
                    outtextxy(w,h,"2B : Hostel 12 > Hostel 8 > SOM > YP Gate > SOM > Hostel 1 > Hostel 5 > Hostel 12");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute2B[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute2B[k])
                {
                    stringstream ss;
                    ss << timeRoute2B[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[5]==true)
    {
        for(k=0; timeRoute3A[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute3A[k])
                {
                    check++;
                    outtextxy(w,h,"3A : Lake Side > Guest House > SOM > Hostel 8 > Hostel 12 > Hostel 5 > Hostel 1 > Hill Side");
                    h+=20;
                    outtextxy(w,h,"> IDC > YP Gate > Hostel 10 > Main Gate > Guest House > Lake Side");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute3A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute3A[k])
                {
                    stringstream ss;
                    ss << timeRoute3A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[6]==true)
    {
        for(k=0; timeRoute3B[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute3B[k])
                {
                    check++;
                    outtextxy(w,h,"3B : Lake Side > Guest House > Main Gate > Hostel 10 > YP Gate > IDC > Hill Side");
                    h+=20;
                    outtextxy(w,h,"> Hostel 1 > Hostel 5 > Hostel 12 > Hostel 8 > SOM > Guest House > Lake Side");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute3B[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute3B[k])
                {
                    stringstream ss;
                    ss << timeRoute3B[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[7]==true)
    {
        for(k=0; timeRoute4A[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute4A[k])
                {
                    check++;
                    outtextxy(w,h,"4 : Hostel 12 > Hostel 8 > SOM > Hostel 8 > Hostel 12");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute4A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute4A[k])
                {
                    stringstream ss;
                    ss << timeRoute4A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[8]==true)
    {
        for(k=0; timeRoute5A[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute5A[k])
                {
                    check++;
                    outtextxy(w,h,"5A : Hostel 5 > Hostel 1 > SOM > Hostel 8 > Hostel 5");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute5A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute5A[k])
                {
                    stringstream ss;
                    ss << timeRoute5A[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    w=10;
    check=0;
    if (boolRoutes[9]==true)
    {
        for(k=0; timeRoute5B[k]!=9999; k++)
        {
            if(check==0)
            {
                if (HHMM < timeRoute5B[k])
                {
                    check++;
                    outtextxy(w,h,"5B : Hostel 5 > Hostel 8 > SOM > Hostel 1 > Hostel 5");
                    h+=20;
                    outtextxy(w,h,"Departure Timings from First Stop :");
                    h+=20;
                    stringstream ss;
                    ss << timeRoute5B[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
            else
            {
                if (HHMM < timeRoute5B[k])
                {
                    stringstream ss;
                    ss << timeRoute5B[k];
                    string s = ss.str();
                    char D[25]={' '};
                    memcpy(D,s.c_str(),s.size());
                    outtextxy(w,h,D);
                    w+=80;
                }
            }
        }
        if(check!=0)
        {
            h+=50;
            cool++;
        }
    }
    if(cool==0)
    {
        settextstyle(6,HORIZ_DIR,5);
        outtextxy(w,h,"No More Tumtums Today");
    }
    }

    setcolor(2);
    rectangle(1200,680,1300,720);
    rectangle(1050,680,1190,720);

    setcolor(3);
    settextstyle(10,HORIZ_DIR,2);
    outtextxy(1225,690,"Exit");
    outtextxy(1068,690,"Main Menu");


    int x,y;
    int divisor;

    T : //Label to initiate mouse click again

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y
    if(((x>=1200)&&(x<=1300))&&((y>=680)&&(y<=720)))
    {
        closegraph();
        return 0;
    }
    else if(((x>=1050)&&(x<=1190))&&((y>=680)&&(y<=720)))
    {
        cleardevice();
        return 1;
    }
    else
    {
        goto T;
    }
}

int tumtum_time()//input for specific timings
{    cleardevice();
     setcolor(3);
     settextstyle(2,HORIZ_DIR,50);
     outtextxy(550,30,"BIITMaps");
     setcolor(RED);
     settextstyle(6,HORIZ_DIR,3);
     outtextxy(200,130,"Please select timing : ");
     setcolor(2);
     rectangle(200,180,450,250);
     rectangle(200,270,450,340);
     rectangle(200,360,450,430);
     rectangle(200,450,450,520);
     rectangle(200,540,450,610);
     rectangle(200,630,450,700);

     rectangle(550,180,800,250);
     rectangle(550,270,800,340);
     rectangle(550,360,800,430);
     rectangle(550,450,800,520);
     rectangle(550,540,800,610);
     rectangle(550,630,800,700);

     rectangle(900,180,1150,250);
     rectangle(900,270,1150,340);
     rectangle(900,360,1150,430);
     rectangle(900,450,1150,520);
     rectangle(900,540,1150,610);
     rectangle(900,630,1150,700);

     setcolor(3);
     settextstyle(6,HORIZ_DIR,4);

     outtextxy(280,200,"630");
     outtextxy(280,290,"730");
     outtextxy(280,380,"830");
     outtextxy(280,470,"930");
     outtextxy(280,560,"1030");
     outtextxy(280,650,"1130");

     outtextxy(630,200,"1230");
     outtextxy(630,290,"1330");
     outtextxy(630,380,"1430");
     outtextxy(630,470,"1530");
     outtextxy(630,560,"1630");
     outtextxy(630,650,"1730");

     outtextxy(980,200,"1830");
     outtextxy(980,290,"1930");
     outtextxy(980,380,"2030");
     outtextxy(980,470,"2130");
     outtextxy(980,560,"2230");
     outtextxy(980,650,"2330");

    int x, y;        // Coordinates of the mouse click
    int divisor;

    S : //Label to initiate mouse click again

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

//The mouse was clicked at x,y

    if(((x>=200)&&(x<=450))&&((y>=180)&&(y<=250)))
    {
     return 630;
    }
    else if(((x>=200)&&(x<=450))&&((y>=270)&&(y<=340)))
    {
     return 730;
    }
    else if(((x>=200)&&(x<=450))&&((y>=360)&&(y<=430)))
    {
     return 830;
    }
    else if(((x>=200)&&(x<=450))&&((y>=450)&&(y<=520)))
    {
     return 930;
    }
    else if(((x>=200)&&(x<=450))&&((y>=540)&&(y<=610)))
    {
     return 1030;
    }
    else if(((x>=200)&&(x<=450))&&((y>=630)&&(y<=700)))
    {
     return 1130;
    }



    else if(((x>=550)&&(x<=800))&&((y>=180)&&(y<=250)))
    {
     return 1230;
    }
    else if(((x>=550)&&(x<=800))&&((y>=270)&&(y<=340)))
    {
     return 1330;
    }
    else if(((x>=550)&&(x<=800))&&((y>=360)&&(y<=430)))
    {
     return 1430;
    }
    else if(((x>=550)&&(x<=800))&&((y>=450)&&(y<=520)))
    {
     return 1530;
    }
    else if(((x>=550)&&(x<=800))&&((y>=540)&&(y<=610)))
    {
     return 1630;
    }
    else if(((x>=550)&&(x<=800))&&((y>=630)&&(y<=700)))
    {
     return 1730;
    }


    else if(((x>=900)&&(x<=1150))&&((y>=180)&&(y<=250)))
    {
     return 1830;
    }
    else if(((x>=900)&&(x<=1150))&&((y>=270)&&(y<=340)))
    {
     return 1930;
    }
    else if(((x>=900)&&(x<=1150))&&((y>=360)&&(y<=430)))
    {
     return 2030;
    }
    else if(((x>=900)&&(x<=1150))&&((y>=450)&&(y<=520)))
    {
     return 2130;
    }
    else if(((x>=900)&&(x<=1150))&&((y>=540)&&(y<=610)))
    {
     return 2230;
    }
    else if(((x>=900)&&(x<=1150))&&((y>=630)&&(y<=700)))
    {
     return 2330;
    }
    else
    {
        goto S;
    }

}

int help()//displays help options
{    cleardevice();
     T:
     setcolor(3);
     settextstyle(2,HORIZ_DIR,50);
     outtextxy(550,30,"Help");
     setcolor(2);
     settextstyle(6,HORIZ_DIR,4);
     outtextxy(30,100,"Get Directions : Displays list of landmarks -> Select any two places");
     outtextxy(30,140,"-> Displays Directions from First to Second -> Map displays as Visual Aid");
     outtextxy(30,200,"Nearest Landmarks : Displays list of landmarks -> Select any place");
     outtextxy(30,240,"-> Displays 3 nearest Landmarks -> Map displays as Visual Aid");
     outtextxy(30,300,"Relative Locations : Displays list of landmarks -> Select any two places");
     outtextxy(30,340,"-> Displays Direction from First to Second and Approx. Distance");
     outtextxy(30,380,"-> Map displays as Visual Aid");
     outtextxy(30,440,"Hangouts : Displays a place suitable for recreational purposes,");
     outtextxy(30,480,"Along with its Timings");
     outtextxy(30,540,"Tumtum : Displays list of landmarks -> Select any two places");
     outtextxy(30,580,"->Displays routes of all Tumtums from First to Second");
     outtextxy(30,620,"Along with their Timings");
     outtextxy(30,680,"Exit : GoodBye !");

    setcolor(2);
    rectangle(1200,680,1300,720);
    rectangle(1050,680,1190,720);

    setcolor(3);
    settextstyle(10,HORIZ_DIR,2);
    outtextxy(1225,690,"Exit");
    outtextxy(1068,690,"Main Menu");

    int x,y;
    int divisor;

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y
    cleardevice();
    if(((x>=1200)&&(x<=1300))&&((y>=680)&&(y<=720)))
    {
        return 0;
    }
    else if(((x>=1050)&&(x<=1190))&&((y>=680)&&(y<=720)))
    {
        return 1;
    }
    else
    {
        goto T;
    }

}

int hangout()//displays randomly a hangout spot
{
    cleardevice();
    setcolor(CYAN);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");
    setcolor(RED);
    settextstyle(6,HORIZ_DIR,6);
    outtextxy(300,200,"Suggested hangout place : ");
    int z;
    string hangouts[]={"Gulmohar ","Coffee Shack, SOM","Brewberry, H8","The Campus Hub"," Sunrise Dhaba","H1 Canteen","Amul Parlour","H2 Canteen","H16 Canteen","H4 Canteen","Boathouse","Sameer Hill","H5 canteen","H12,13,14 Canteen","H9 Canteen"};
    string times[]={"1130 to 2200","0900 to 1800","1230 to 0200","1800 to 0400","1800 to 0030","2000 to 0300","1100 to 0100","2000 to 0300","1800 to 0200","2000 to 0300","entire  day","0600 to 1800","2000 to 0300","2200 to 0400","2000 to 0300"};
    srand(time(NULL));
    z=rand()%15;
    T:
    setcolor(CYAN);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(550,60,"BIITMaps");
    setcolor(RED);
    settextstyle(6,HORIZ_DIR,6);
    outtextxy(300,200,"Suggested hangout place : ");

    char D[25]={' '};
    memcpy(D,hangouts[z].c_str(),hangouts[z].size());
    outtextxy(700-(20*hangouts[z].size()),350,D);
    outtextxy(520,500,"Timings :");
    char D1[25]={' '};
    memcpy(D1,times[z].c_str(),times[z].size());
    outtextxy(700-(20*times[z].size()),650,D1);

    setcolor(2);
    rectangle(1200,680,1300,720);
    rectangle(1050,680,1190,720);

    setcolor(3);
    settextstyle(10,HORIZ_DIR,2);
    outtextxy(1225,690,"Exit");
    outtextxy(1068,690,"Main Menu");

    int x,y;
    int divisor;

    while (!ismouseclick(WM_LBUTTONDOWN))
    {
        divisor++;
    }

    getmouseclick(WM_LBUTTONDOWN, x, y);

    //The mouse was clicked at x,y
    cleardevice();
    if(((x>=1200)&&(x<=1300))&&((y>=680)&&(y<=720)))
    {
        closegraph();
        return 0;
    }
    else if(((x>=1050)&&(x<=1190))&&((y>=680)&&(y<=720)))
    {
        cleardevice();
        return 1;
    }
    else
    {
        goto T;
    }
}

void thanks()//exit message
{
    cleardevice();
    setcolor(CYAN);
    settextstyle(2,HORIZ_DIR,50);
    outtextxy(500,360,"Thank You!");
    delay(1000);
    exit(0);
}
